CON

  _CLKMODE = XTAL1 + PLL16X ' The clock frequency is equal to 96MHz = 6MHz * 16X PLL.
  _XINFREQ = 6_000_000 '

  _SD_DO = 16 ' Secure digital card pins.
  _SD_CLK = 17 '
  _SD_DI = 18 '
  _SD_CS = 19 '
  _SD_CD = 15 '
  _SD_WP = -1 '

  _SERIAL_TX_PIN = 30 ' Asynchronous serial bus pins.
  _SERIAL_RX_PIN = 31 '

OBJ

  com: "Full-Duplex_COMEngine.spin"
  fat: "SD-MMC_FATEngine.spin"

PUB main

  com.COMEngineStart(_SERIAL_RX_PIN, _SERIAL_TX_PIN, 19200)
  fat.FATEngineStart(_SD_DO, _SD_CLK, _SD_DI, _SD_CS, _SD_WP, _SD_CD, -1, -1, -1)

  waitcnt((clkfreq * 5) + cnt)
  com.writeString(string("-00-", 13))
  
  result := \launch ' ASSIGN return values from an abort trapped function into a variable or you will have problems!!!
  com.writeString(result) ' The assignment must literally be on a seperate line!!!

  if(fat.partitionError)
    com.writeByte(13)
  
  fat.unmountPartition 
  com.writeString(string("-10-", 13))

PRI launch | entryName

  com.writeString(string("-01-", 13))
  fat.mountPartition(0)
  com.writeString(string("-02-", 13))
 
  fat.listEntries("W")
  repeat while(entryName := fat.listEntries("N"))
    com.writeString(entryName)
    com.writeByte(13)

  com.writeString(string("-03-", 13)) 
  fat.changeDirectory(string("\DIR1"))
  com.writeString(string("-04-", 13))  
                                
  fat.listEntries("W") ' <---------------------------------THIS is the line of code needed. You didn't reset the listing pointer.
  repeat while(entryName := fat.listEntries("N"))
    com.writeString(entryName)
    com.writeByte(13)

  com.writeString(string("-05-", 13))
  fat.newDirectory(string("test1"))
  com.writeString(string("-06-", 13))
  fat.changeDirectory(string("test1"))
  com.writeString(string("-07-", 13)) 
  
  fat.listEntries("W")
  repeat while(entryName := fat.listEntries("N"))
    com.writeString(entryName)
    com.writeByte(13)

  com.writeString(string("-08-", 13)) 
  fat.unmountPartition
  com.writeString(string("-09-", 13)) 
  